LFSegmenter
==========

Implementation of 4D light-field segmentation method for ICCP'16 ``4D Light Field Segmentation with Spatial and Angular Consistencies'' and part of Hajime Mihara's Master Thesis.
This tool is built by C++ and Python. (So it is not clear project well...)

## Environment
I only confirm in Ubuntu 14.04 for correct work.

## Structure
This project is separated into two parts, objectness calculator and 4D graph-cut.
The objectness calculator is implemented by Python 2.x and graph-cut is implemented by C++.
I am sorry about such a strange project...

~~~~
LFSegmenter/------run.py
		|-result.py
		|-classifier/---|-getFeature_libsvm.py (This is the main implementation for getting obejctness)
		|		|- (some python scripts which is imported in getFeatrue_libsvm.py)
		|
		|-LFCuts/---------compile.sh (sorry about I did not write Makefile...)
				|-LFCuts_w_multi_likelihood.cpp
				|-(other regacy implementation)
		|-LF/-------------(some light-field datasets)-----0_0.png
								|  ...
								|-5_5.png
								|-config.txt (write parameter for objectness)
								|-script.txt (write parameter for graphcuts)
								|-disparity/----0_0.png ~ 5_5.png
								|-likelihood/---0_0.png ~ 5_5.png
								|-out/
								|-seed0.png ~seedN.png
~~~~
## Built-in Library
Objectness calculator uses modefied LibSVM. This is in LFSegmenter/lib/libsvm_mod .
Graph-cut part uses graph-cut library which is in http://vision.csd.uwo.ca/code/. 
This library is in LFSegmenter/lib/gco-v3.0 too.

## Dependency 
You have to install these;
* Python 2.7.x (I use 2.7.6, 3.x.x is not suitable.)
* OpenCV v2.4.8
* GCC (I use v4.8.4)
* Numpy


## Installation

	$ cd path/to/LFSegmenter/
	$ cd LFCuts/
	$ ./compile.sh (sorry about such an infantile method.)
	$ ../

## Usage

	$ python run.py LF/(dataset)/ (class_num)

E.g.
	$ python run.py LF/papillon/ 4

After running, accuracy is caluculated automatically like this;
E.g.

	0_0 acc: 98.4242757161
	0_1 acc: 98.4008789062
	...	
	4_3 acc: 97.3914252387
	4_4 acc: 96.6740926107
	result: 97.7447102865
	variance: 0.476014012264

Segmented light-field is stored into out/
The directory out/ have 0/ to (class_num)/ subdirs.
These contains the segmented region which corresponds to the class.

run.py calls some scripts and binary.
Firstly run.py calls objectness calculator, classifier/getFeature_libsvm.py.
It takes too much time...

Secondly, run.py calls LFCuts/LFCuts .
Finally, run.py calls result.py.
result.py outputs images 0_0.png to 5_5.png which represents assigned label.
These labeled images are grayscale images.


## Others
If you have something in trouble, please contact to Hajime Mihara, 

* mailto:hajimemihara1108@gmail.com
* skype:mhr380


