import numpy as np
import cv2
import h5py
import sys

def load_png(src_name, disp_name):
    print('load png image')
    img = cv2.imread(src_name, 1)
    disp_img = cv2.imread(disp_name, 0)

    return img, disp_img

def load_h5(path):
    print('load h5 data')
    try:
        print(path + 'lf.h5')
        h5file = h5py.File(path + 'lf.h5', 'r')
        return h5file
    except IOError:
        print('IOError')
        sys.exit()

    return h5file

def h5_to_img(path, h5file):
    item_list = [h5file.items()[i][0] for i in xrange(len(h5file.items()))]
    for item in item_list:
        data = h5file[item].value   # Access to the GROUP using .value method
        l = len(data.shape)         # l = 4 corresponds to a depthmap, 5 corresponds to LFs

        #if l == 4:
        #    disp = np.array(data[4, 4, :, :], np.float64)

        #    ave = np.average(disp)
        #    std = np.std(disp + 0.001)

        #    ave_array = np.ones(disp.shape) * ave
        #    disp = ( (disp - ave_array ) / std  ) 

        #    cv2.imwrite(path + 'disparity.png', (disp - disp.min()) * 50)

        if l == 5:
            raw_img = np.array(data[4, 4, :, :, :], np.uint8)
            # swap RGB to GBR
            img = np.zeros(raw_img.shape, np.uint8)
            img[:, :, 0] = raw_img[:, :, 2].copy()
            img[:, :, 1] = raw_img[:, :, 1].copy()
            img[:, :, 2] = raw_img[:, :, 0].copy()
            cv2.imwrite(path + 'img.png', img)
    return img

if __name__ == '__main__':
    print('use only to import this')
