import numpy as np
import cv2
import h5py
import sys

def load_h5(path):
    print 'load h5 data'
    try:
        h5file = h5py.File(path, 'r')
        return h5file
    except IOError:
        print 'IOError'
        sys.exit()

    return h5file

def h5_to_label(h5file, saveDir):

    item_list = [h5file.items()[i][0] for i in xrange(len(h5file.items()))]
    print item_list
    for item in item_list:
        if item == u'SCRIBBLES':
            data = h5file[item].value   # Access to the GROUP using .value method

            print data.shape

            img = np.array(data)
            for l in xrange(1, np.max(img) + 1):
                limg = np.zeros((img.shape[0], img.shape[1], 4))
                limg[:, :, :3]  = cv2.imread('./2_2.png', 1).copy()
                fname = saveDir + '/seed' + str(l-1) + '.png'
                mask = (img == l)
                limg[:, :, 3][mask]  = 255
                cv2.imwrite(fname, limg)
                cv2.imshow('win', limg)
                cv2.waitKey(0)
    return

def h5_to_img(path, h5file):
    item_list = [h5file.items()[i][0] for i in xrange(len(h5file.items()))]
    for item in item_list:
        data = h5file[item].value   # Access to the GROUP using .value method
        l = len(data.shape)         # l = 4 corresponds to a depthmap, 5 corresponds to LFs


        if l == 4:
            print 'disparity'
            for v in range(data.shape[0]):
                for u in range(data.shape[1]):
                    raw_img = np.array(data[v, u, :, :], np.float64)
                    img_name = str(v) + '_' + str(u) + '.png'

                    d_max = np.max(raw_img)
                    d_min = np.min(raw_img)

                    img = 100. / (1. + np.exp(-0.2 * raw_img * 10. ))
                    #img =  raw_img * 40
                    img.astype(np.uint8)
                    write_path = path + 'dispset/' + img_name
                    print write_path
                    cv2.imwrite(write_path, img)
                    write_path = path + 'disparity/' + img_name
                    cv2.imwrite(write_path, img)
        return

        if l == 5:
            print 'save img'
            for v in range(data.shape[0]):
                for u in range(data.shape[1]):
                    raw_img = np.array(data[v, u, :, :, :], np.uint8)
                    # swap RGB to GBR
                    img = np.zeros(raw_img.shape, np.uint8)
                    img[:, :, 0] = raw_img[:, :, 2].copy()
                    img[:, :, 1] = raw_img[:, :, 1].copy()
                    img[:, :, 2] = raw_img[:, :, 0].copy()
                    img_name = str(v) + '_' + str(u) + '.png'
                    cv2.imwrite(path + 'full_lf/' + img_name, img)
    return

if __name__ == '__main__':

    lf_path = sys.argv[1] 
    print lf_path
    h5file = load_h5(lf_path)
    h5_to_img("./", h5file)
