import cv2
import numpy as np 
import sys

#path = 'out/'
path = sys.argv[1]
outpath = sys.argv[2]

def load_img(fname):
    img = cv2.imread(fname, 1)
    return img

def composite(num, d, LFs):

    H, W = LFs[0].shape[:2]

    print d

    ctr = num
    tmp = np.zeros((H, W, 3))

    for j in range(num * 2 + 1):
        for i in range(num * 2 + 1):

            k = j * (num * 2 + 1) + i 

            dh = round(d / 10. * (j - ctr))
            #dw = (-1) * d * (i - ctr)
            dw = round(d / 10. * (i - ctr))

            if dh >= 0 and dw >=0:
                tmp[0: H - dh, 0: W - dw, :]    += LFs[k][dh: H, dw: W, :] 
            if dh >= 0 and dw < 0:
                tmp[0: H - dh, -dw: W, :]       += LFs[k][dh: H, 0: W + dw, :] 
            if dh < 0  and dw >= 0:
                tmp[-dh: H, 0: W - dw, :]       += LFs[k][0: H + dh, dw: W, :] 
            if dh < 0  and dw < 0:
                tmp[-dh: H, -dw: W, :]          += LFs[k][0: H + dh, 0: W + dw, :] 

    cv2.imwrite(outpath + str(num) + '_' + str(d) + '.png', tmp / ((num * 2 + 1) * (num * 2 + 1)))

if __name__ == '__main__':

    #for N in [9, 7, 5, 3]:
    for N in [9]:
        N_max = 9
        #N = int(sys.argv[1])
        num = int(N / 2)

        LFs = [0] * (N)
        m = N_max / 2 - num 

        idx = [m + i for i in range(num * 2 + 1)]
        print idx

        name_list = [path+str(j)+'_'+str(i)+'.png' for j in idx for i in idx]
        for name in name_list:
            print name

            LFs = map(load_img, name_list)

        for d in xrange(-15, 15):
            composite(num, d, LFs)
